/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtAdapterJava.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtAdapterJava'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVTADAPTERJAVA_H
#define _EVTADAPTERJAVA_H

//@START_USER1
#include <osgGA/GUIEventAdapter>

namespace cooki3d{
//@END_USER1


/*@NOTE_1725
class ...
*/

class AFX_EXT_CLASS EvtAdapterJava
    : public osgGA::GUIEventAdapter
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//

protected:
    virtual ~EvtAdapterJava();

public:
    EvtAdapterJava();
    static void fireJavaEventKey(int keycode, long bdRef);
    static void fireJavaEventMouse(int x, int y, int mask, int type, long bdRef);
    static void fireJavaEventMouseDragged(int x, int y, int mask, long bdRef);
    static void fireJavaEventMouseMoved(int x, int y, int mask, long bdRef);
    static void fireJavaEventMousePressed(int x, int y, int mask, long bdRef);
    static void fireJavaEventMouseReleased(int x, int y, int mask, long bdRef);
};

#endif


#ifdef CB_INLINES
#ifndef _EVTADAPTERJAVA_H_INLINES
#define _EVTADAPTERJAVA_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
