/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Function_0arg.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Function_0arg'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _FUNCTION_0ARG_H
#define _FUNCTION_0ARG_H

//@START_USER1
 #include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_535
class ...
*/

class AFX_EXT_CLASS Function_0arg
    : public Command
{

//@START_USER2
public:
  typedef void Fonction(void);
  typedef Fonction * FonctionPTR;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    FonctionPTR _fonction;

//
// Non-Grouped Methods
//

public:
    Function_0arg(BD* pBD, std::string nom, FonctionPTR fonction);
    virtual ~Function_0arg();
    virtual void exec();
};

#endif


#ifdef CB_INLINES
#ifndef _FUNCTION_0ARG_H_INLINES
#define _FUNCTION_0ARG_H_INLINES

/*@NOTE_536
  Destructor method.
*/
inline Function_0arg::~Function_0arg()
{//@CODE_536
  DestructorInclude();
  
  // Put in your own code
}//@CODE_536



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
