/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Function_1arg.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Function_1arg<Arg1>'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _FUNCTION_1ARG_H
#define _FUNCTION_1ARG_H

//@START_USER1
//#include "XMLUtil.h"
//#include "yaccLex/Pile.h"
//#include "Evaluable.h"
//#include "Event.h"
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_405
class ...
*/
template<class Arg1>
class Function_1arg
    : public Command
{

//@START_USER2
public:

    //typedef map<string,Evaluable *,less<string > > mapStrThis;

  typedef void Fonction(Arg1);
  typedef Fonction * FonctionPTR;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    FonctionPTR _fonction;
    Arg1 _arg1;

//
// Non-Grouped Methods
//

public:
    Function_1arg(BD* pBD, std::string nom, FonctionPTR fonction);
    virtual ~Function_1arg();
    virtual void exec();
    virtual void pSetArg1(void* arg1);
    Arg1 getArg1() const;
    void setArg1(Arg1 arg1);
};

#endif


#ifdef CB_INLINES
#ifndef _FUNCTION_1ARG_H_INLINES
#define _FUNCTION_1ARG_H_INLINES


//
// Group: ClassBuilder methods
//
/*@NOTE_407
Method which must be called first in a constructor.
*/
template<class Arg1>
void Function_1arg<Arg1>::ConstructorInclude()
{
}



/*@NOTE_408
Method which must be called first in a destructor.
*/
template<class Arg1>
void Function_1arg<Arg1>::DestructorInclude()
{
}



// End of Group: ClassBuilder methods

/*@NOTE_411
Constructor method.
*/
template<class Arg1>
inline Function_1arg<Arg1>::Function_1arg(BD* pBD, std::string nom,
                                          FonctionPTR fonction) //@INIT_411
    :Command(pBD)
    ,_fonction(fonction)
    , _arg1()
{//@CODE_411
    ConstructorInclude();

    // Put in your own code
    setName(nom);
}//@CODE_411



/*@NOTE_406
  Destructor method.
*/
template<class Arg1>
inline Function_1arg<Arg1>::~Function_1arg()
{//@CODE_406
  DestructorInclude();
  
  // Put in your own code
}//@CODE_406



template<class Arg1>
void Function_1arg<Arg1>::exec()
{//@CODE_465
    _fonction(_arg1);
}//@CODE_465



template<class Arg1>
void Function_1arg<Arg1>::pSetArg1(void* arg1)
{//@CODE_5235
    setArg1( *((Arg1*)(arg1)));
}//@CODE_5235



/*@NOTE_1062
Returns the value of member '_arg1'.
*/
template<class Arg1>
inline Arg1 Function_1arg<Arg1>::getArg1() const
{//@CODE_1062
    return _arg1;
}//@CODE_1062



/*@NOTE_1063
Set the value of member '_arg1' to 'arg1'.
*/
template<class Arg1>
inline void Function_1arg<Arg1>::setArg1(Arg1 arg1)
{//@CODE_1063
    _arg1 = arg1;
}//@CODE_1063



//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
