/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MapRW.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MapRW'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _MAPRW_H
#define _MAPRW_H
#include <iostream>
#include <fstream>

using namespace std;

//@START_USER1
#include <map>
#include <vector>
//#include <sstream>

#ifndef CB_INLINES
#error CB_INLINES non défini!!
#endif

#ifdef _MAPRW_H_INLINES
#error _MAPRW_H_INLINES déjà défini!!
#endif

namespace cooki3d{
//@END_USER1


/*@NOTE_116
class ...
*/

class AFX_EXT_CLASS MapRW
{

//@START_USER2
 public:
  typedef map<string,string,less<string > > mapStrStr;
  struct Ligne {
    string nom, champs;
  };
  
  typedef vector<Ligne> tabStrStr;

  typedef map<string,int,less<string > > mapStrInt;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//

public:
    MapRW();
    virtual ~MapRW();
    void convertDosEOL(std::string& s);
    int extractFirstInt(std::string& s);
    std::string extractFirstStr(std::string& s);
    std::string getExtension(std::string nomFic);
    void loadMapStrStr(std::string ficname, mapStrStr& m);
    void loadTabStrStr(std::string ficname, tabStrStr& tab, char separ);
    void loadTabStrStr(std::string ficname, tabStrStr& tab);
    void split(std::string s, std::string& p, std::string& f, std::string& ext);
    void writeToStr(int item, std::string& s);
    void writeToStr(double item, std::string& s);
    void writeToStr(float item, std::string& s);
    void writeToStr(unsigned int item, std::string& s);
};

#endif


#ifdef CB_INLINES
#ifndef _MAPRW_H_INLINES
#define _MAPRW_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
