/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          ThreadSdl.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'ThreadSdl'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "ThreadSdl.h"
#include "LoaderXML.h"
#include <SDL/SDL.h>

int thread_funcSDL(void *unused)
{
  ThreadSdl* thisObj=(ThreadSdl*)unused;
  assertC2(thisObj, NULL);
  
  try {
    
    CTRACEs("thread_funcSDL")
      <<"thread_funcSDL this unused="<<thisObj<<endl;
    
    
    /*int last_value = 0;
      while ( global_data != -1 ) {
      if ( global_data != last_value ) {
      printf("Data value changed to %d\n", global_data);
      last_value = global_data;
      }
      SDL_Delay(100);
      }*/
    // SDL_Delay(100);
    thisObj->run();
    //thisObj->_runEnd = true;
    
    CTRACEs("thread_funcSDL")<<"Thread "<<thisObj<<" quitting \n";
    
  }
  catch( EnvironnementInstanceException ){
    CERRs("thread_funcSDL")
      <<"Exception EnvironnementInstanceException caught !! "
      <<  std::endl;
  }
  catch(AssertException e){
      CERRs("thread_funcSDL") 
	<< "Exception StopException caught !! "
	<<  std::endl;
      //thisObj->kill();
      CERRnext<<e.getStackTrace()<<endl;
      thisObj->getBD()->getEnv()->stop();
  }
  catch( ... ) {
    CERRs("mainCooki")  << "Exception caught !! "<<  std::endl;
    thisObj->getBD()->getEnv()->stop();
  }
    
  return(0);
}
namespace cooki3d{
//@END_USER2




/*@NOTE_1109
Constructor method.
*/
ThreadSdl::ThreadSdl(BD* pBD) //@INIT_1109
  : Evaluable(pBD)
  , _vivant(true)
  , _runEnd(true)
{//@CODE_1109
  ConstructorInclude();
  
  //assertC(_taches.size());
  //_tacheIT=_taches.begin();
  
  setName( "threadSDL" );
  
  // Put in your own code
  CTRACE(this,"ThreadSdl")<<"new Threadd SDL"<<endl;
  //_runEnd = true;
}//@CODE_1109


/*@NOTE_1102
  Destructor method.
*/
ThreadSdl::~ThreadSdl()
{//@CODE_1102
  DestructorInclude();
  
  // Put in your own code
  
}//@CODE_1102


void ThreadSdl::kill()
{//@CODE_1110
    _vivant = false;
        
    CTRACE(this,"kill")<<"kill thread request : "<<this<<endl;
    
    SDL_WaitThread(_thread, NULL);
    
    //while (!_runEnd);

    CTRACE(this,"kill")<<"kill thread : "<<this<<" OK"<<endl;

}//@CODE_1110


void ThreadSdl::run()
{//@CODE_1112
    CERR(this,"run2")<<"Threadd::run2() is pure virtual methode"<<endl; 
    assertC(0);
    //exit(-1)
}//@CODE_1112


void ThreadSdl::start()
{//@CODE_1111
    _runEnd = false;
    _thread = SDL_CreateThread(thread_funcSDL, this);
    if ( _thread == NULL ) {
      CERR(this,"run")<<"Unable to create thread: "<<SDL_GetError()<<endl;
      //fprintf(stderr, "Unable to create thread: %s\n", SDL_GetError());
      _runEnd = true;
      return;
    }
    //this->run2();
    //_runEnd = true;
}//@CODE_1111


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1103
Method which must be called first in a constructor.
*/
void ThreadSdl::ConstructorInclude()
{
}


/*@NOTE_1104
Method which must be called first in a destructor.
*/
void ThreadSdl::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
/*#include "SDL_thread.h"

int global_data = 0;

int thread_func(void *unused)
{
    int last_value = 0;

    while ( global_data != -1 ) {
        if ( global_data != last_value ) {
            printf("Data value changed to %d\n", global_data);
            last_value = global_data;
        }
        SDL_Delay(100);
    }
    printf("Thread quitting\n");
    return(0);
}

{
    SDL_Thread *thread;
    int i;

    thread = SDL_CreateThread(thread_func, NULL);
    if ( thread == NULL ) {
        fprintf(stderr, "Unable to create thread: %s\n", SDL_GetError());
        return;
    }

    for ( i=0; i<5; ++i ) {
        printf("Changing value to %d\n", i);
        global_data = i;
        SDL_Delay(1000);
    }

    printf("Signaling thread to quit\n");
*/
