#include <jni.h> 
#include "jni_cpp_Interfacage.h" 
#include <stdio.h>
#include <stdlib.h>


#include <sys/fcntl.h>

#ifdef UNIX
#include <dlfcn.h>
#include <sys/types.h>
#include <unistd.h>
#else
#include <windows.h>
#include <process.h>
#endif


//using namespace std;



extern "C" 
JNIEXPORT void JNICALL Java_jni_cpp_Interfacage_SetEnv
(JNIEnv * env,jobject, jstring jMsg) {


  //printf("ModuleSetEnv : Java_jni_cpp_Interfacage_SetEnv\n");

  const char* msg=env->GetStringUTFChars(jMsg,0);
  
  putenv((char*)msg);

  printf("ModuleSetEnv :putenv %s\n",msg);
  
}


extern "C" 
JNIEXPORT jint JNICALL Java_jni_cpp_Interfacage_GetPid
(JNIEnv * env,jobject) {

  return getpid();
  
  
}

extern "C" 
JNIEXPORT jint JNICALL Java_jni_cpp_Interfacage_SynLinkForce
  (JNIEnv * env, jobject, jstring jOldPath, jstring jNewPath){

#ifdef UNIX
  const char* newPath=env->GetStringUTFChars( jNewPath,0);
  const char* oldPath=env->GetStringUTFChars( jOldPath,0);
  
  unlink( newPath );
  return symlink( oldPath, newPath );  
#endif
  return -1;

}








// bool load(const char * lib){
//   void* _libsys = NULL;
  
// #ifdef UNIX
//   if (!((_libsys = dlopen( lib , RTLD_NOW | RTLD_GLOBAL/*RTLD_LOCAL*/)))) //  
//     {
//       cerr<<" lib="<<lib<<" erreur dlopen "<<dlerror()<<endl;
//       exit(-1);
//       return false;
//     }
// #else
//   _libsys = LoadLibrary(lib).c_str());

// // Load the DLL
//   if ( !_libsys) {
//     cerr<" lib="<<lib<<" erreur open dll "<<endl;
//     return false;
//   }
// #endif 

// cout<<"load"<<lib<<" OK"<<endl;
// return true;
// }

// extern "C" 
// JNIEXPORT void JNICALL Java_editeur_cpp_Interfacage_SetEnv
// (JNIEnv * env,jclass, jstring jMsg, jstring jLib) {


// printf("ModuleSetEnv : Java_editeur_cpp_Interfacage_SetEnv\n");

// const char* msg=env->GetStringUTFChars(jMsg,0);
// const char* lib=env->GetStringUTFChars(jLib,0);
    

//   char *var = getenv("LD_LIBRARY_PATH");

//   if (var != NULL){
//     printf("avant la valeur de LD_LIBRARY_PATH était %s\n", var );
//   }else {
//     printf("avant la valeur de LD_LIBRARY_PATH était NULL\n");
// }

// unsetenv("LD_LIBRARY_PATH");

//   putenv((char*)msg);

//   printf("ModuleSetEnv :putenv %s\n",msg);

//   //vérifiaction
//   var = getenv("LD_LIBRARY_PATH");  
//   printf("set LD_LIBRARY_PATH = %s\n", var );

// load(lib);

// }
