#include <jni.h> 
#include "jni_canvas_CanvasListener.h" 
#include <iostream>

#include "../CookiMetier.h"
#include "../EvtAdapterJava.h"

using namespace std;


extern "C" JNIEXPORT void JNICALL Java_jni_canvas_CanvasListener_mousePressedNative (JNIEnv * env, jobject jo,jint x,jint y,jint mask, jlong bdRef){ 
  try {
    EvtAdapterJava::fireJavaEventMousePressed( (int) x, (int) y, (int) mask
					       , bdRef);  
  }
  catch( ... ) {
    CERRs("Java_jni_canvas_CanvasListener_mousePressedNative")  
      << "Exception caught !! "<<  std::endl;    
  }
}

extern "C" JNIEXPORT void JNICALL Java_jni_canvas_CanvasListener_mouseMovedNative  (JNIEnv * env, jobject jo, jint x, jint y,jint mask, jlong bdRef){
  try {
    EvtAdapterJava::fireJavaEventMouseMoved( (int) x, (int) y,(int) mask
					     , bdRef);
  }
  catch( ... ) {
    CERRs("Java_jni_canvas_CanvasListener_mouseMovedNative")  
      << "Exception caught !! "<<  std::endl;    
  }
}

extern "C" JNIEXPORT void JNICALL Java_jni_canvas_CanvasListener_mouseDraggedNative  (JNIEnv * env, jobject jo, jint x, jint y,jint mask, jlong bdRef){
  try {
    EvtAdapterJava::fireJavaEventMouseDragged( (int) x, (int) y,(int) mask
					       , bdRef);
  }
  catch( ... ) {
    CERRs("Java_jni_canvas_CanvasListener_mouseDraggedNative")  
      << "Exception caught !! "<<  std::endl;    
  }
}

extern "C" JNIEXPORT void JNICALL Java_jni_canvas_CanvasListener_mouseReleasedNative  (JNIEnv * env, jobject jo, jint x, jint y,jint mask, jlong bdRef){
  try {
    EvtAdapterJava::fireJavaEventMouseReleased( (int) x, (int) y,(int) mask
						, bdRef);
  }
  catch( ... ) {
    CERRs("Java_jni_canvas_CanvasListener_mouseReleasedNative")  
      << "Exception caught !! "<<  std::endl;    
  }
}

                                  
extern "C" JNIEXPORT void JNICALL Java_jni_canvas_CanvasListener_dispatchKeyNative  (JNIEnv * env, jobject jo, jint keycode, jlong bdRef){
  try {
    EvtAdapterJava::fireJavaEventKey( (int) keycode
				      , bdRef);
  }
  catch( ... ) {
    CERRs("Java_jni_canvas_CanvasListener_dispatchKeyNative")  
      << "Exception caught !! "<<  std::endl;    
  }
}

