/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          CommandThreadSdl.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'CommandThreadSdl'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _COMMANDTHREADSDL_H
#define _COMMANDTHREADSDL_H

//@START_USER1
#include "Evaluable.h"
#include "ThreadSdl.h"
#include "Command.h"
namespace cooki3d{
//@END_USER1


/*@NOTE_4741
class ...
*/

class AFX_EXT_CLASS CommandThreadSdl
    : public ThreadSdl
{

//@START_USER2
  typedef void Fonction();
  typedef Fonction * FonctionPTR;
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    Command* _command;

//
// Non-Grouped Methods
//

private:
    virtual void run();

public:
    CommandThreadSdl(BD* pBD, Command* command);
    virtual ~CommandThreadSdl();
};

#endif


#ifdef CB_INLINES
#ifndef _COMMANDTHREADSDL_H_INLINES
#define _COMMANDTHREADSDL_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
