/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          EvtHandler.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'EvtHandler'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _EVTHANDLER_H
#define _EVTHANDLER_H

//@START_USER1
#include "EnvironnementProducer.h"


namespace cooki3d{

  class EnvironnementOSG;
//@END_USER1


/*@NOTE_92
classe ...
*/

class AFX_EXT_CLASS EvtHandler
    : public osgGA::GUIEventHandler
{

//@START_USER2
 /*   bool handlerDiscret;    
public:       
    void setHandlerDiscret(bool b){    handlerDiscret=b; }*/
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    EnvironnementOSG* _envOSG;

//
// Non-Grouped Methods
//

public:
    EvtHandler(EnvironnementOSG* envOSG);
    virtual ~EvtHandler();
    virtual void accept(osgGA::GUIEventHandlerVisitor& gehv);
    virtual void getUsage(osg::ApplicationUsage& rUsage) const;
    virtual bool handle(const osgGA::GUIEventAdapter& ea,
                        osgGA::GUIActionAdapter& aa);
};

#endif


#ifdef CB_INLINES
#ifndef _EVTHANDLER_H_INLINES
#define _EVTHANDLER_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
