/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Media.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Media'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "Media.h"
namespace cooki3d{
//@END_USER2




/*@NOTE_160
Constructor method.
*/
Media::Media() //@INIT_160
    
{//@CODE_160
    ConstructorInclude();

    

    // Put in your own code
}//@CODE_160


/*@NOTE_150
Destructor method.
*/
Media::~Media()
{//@CODE_150
    DestructorInclude();

    // Put in your own code
}//@CODE_150


double Media::eval(std::string methode, double args[10], int nbParam)
{//@CODE_322
    
  cout<<"------------------------------thisMedia::eval : "<<methode<<endl;

  if (methode == "isPause"){
    return (double)isPause();
  }
  if (methode == "isPlay"){
    return (double)isPlay();
  }
  if (methode == "getPosition"){
    return (double)getPosition();
    //return 0.0;
  }
  if (methode == "play"){
    play();
    return 1.0;
  }
  if (methode == "pause"){
    pause();
    return 1.0;
  }
  if (methode == "stop"){
    stop();
    return 1.0;
  }
  if (methode == "getDuration"){
    return getDuration();
  }
  if (methode == "setPosition"){
    cout<<"args[0]="<<args[0]<<endl;
    setPosition(args[0]);
    return 1.0;
  }  
  
  CERR(this, "eval")<<" methode '"<<methode<<"' is not reconized"<<endl;

  return 0;
}//@CODE_322


double Media::getPosition()
{//@CODE_301
  CERR(this,"getPosition")<< "'pur virtual use !'"<<endl;
  return 0;
}//@CODE_301


bool Media::isPause()
{//@CODE_300
  CERR(this,"isPause")<< "'pur virtual use !'"<<endl;
  return false;
}//@CODE_300


bool Media::isPlay()
{//@CODE_299
  CERR(this,"isPlay")<< "'pur virtual use !'"<<endl;
  return false;
}//@CODE_299


void Media::setPositionPercentage(int pc)
{//@CODE_635
    setPosition( double(pc)*getDuration()/100.0 );
    
}//@CODE_635


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_151
Method which must be called first in a constructor.
*/
void Media::ConstructorInclude()
{
}


/*@NOTE_152
Method which must be called first in a destructor.
*/
void Media::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
