/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Media.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Media'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _MEDIA_H
#define _MEDIA_H

//@START_USER1
// #ifdef CB_INLINES
// #undef CB_INLINES
// #define MODIF_MEDIABD_H
// #endif 
// class Media;

// //#include "MediaInterface.h"
// //#include "Media.h"
// //#include "BD.h"
// //#include "Evaluable.h"

// #ifdef MODIF_MEDIABD_H
// #define CB_INLINES
// #undef MODIF_MEDIABD_H
// #endif

//pour le namespace soit bien refermé!!
#ifdef _MEDIA_H_INLINES
#error MEDIA_H_INLINES
#undef _MEDIA_H_INLINES
#endif
#ifndef CB_INLINES
#error MEDIA_H CB_INLINES
#endif

namespace cooki3d{
//@END_USER1


/*@NOTE_149
classe ...
*/

class AFX_EXT_CLASS Media
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

//
// Non-Grouped Methods
//

public:
    Media();
    virtual ~Media();
    virtual double eval(std::string methode, double args[10], int nbParam);
    virtual double getDuration() = 0;
    virtual double getPosition() = 0;
    virtual bool isPause() = 0;
    virtual bool isPlay() = 0;
    virtual void pause() = 0;
    virtual void play() = 0;
    virtual void setDuration(double duree) = 0;
    virtual void setPosition(double sec) = 0;
    void setPositionPercentage(int pc);
    virtual void stop() = 0;
};

#endif


#ifdef CB_INLINES
#ifndef _MEDIA_H_INLINES
#define _MEDIA_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
