/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          MediaEvaluable.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'MediaEvaluable'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "MediaEvaluable.h"
namespace cooki3d{
//@END_USER2




/*@NOTE_1287
Constructor method.
*/
MediaEvaluable::MediaEvaluable(BD* pBD) //@INIT_1287
    : Evaluable(pBD)
      ,_playOnStart(false)
{//@CODE_1287
    ConstructorInclude();

    

    // Put in your own code
}//@CODE_1287


/*@NOTE_1283
Destructor method.
*/
MediaEvaluable::~MediaEvaluable()
{//@CODE_1283
    DestructorInclude();

    // Put in your own code
}//@CODE_1283


double MediaEvaluable::eval(std::string methode, double args[10], int nbParam)
{//@CODE_1334
    return Media::eval(methode,args,nbParam);
}//@CODE_1334


double MediaEvaluable::getPosition()
{//@CODE_1297
    double value;
    assertC(0);
    return value;
}//@CODE_1297


bool MediaEvaluable::isPause()
{//@CODE_1293
    bool value;
    assertC(0);
    return value;
}//@CODE_1293


bool MediaEvaluable::isPlay()
{//@CODE_1292
    bool value;
    assertC(0);
    return value;
}//@CODE_1292


void MediaEvaluable::playInstancesOnStart(BD* pBD)
{//@CODE_1367

  BD::EvaluableIterator itMed( pBD );
  
  MediaEvaluable * me;
  
  while (++itMed){
    me=dynamic_cast<MediaEvaluable *>(itMed.Get());
    if (me ){
      if (me->getPlayOnStart() ) {
	CTRACEs("MediaEvaluable::playInstancesOnStart")
	  <<" démarrage du Média évaluable "<<me->getName();
	me->play();      
      }          
    }
  }

}//@CODE_1367


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_1284
Method which must be called first in a constructor.
*/
void MediaEvaluable::ConstructorInclude()
{
}


/*@NOTE_1285
Method which must be called first in a destructor.
*/
void MediaEvaluable::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
