/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          ThreadSdl.h
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'ThreadSdl'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
#ifndef _THREADSDL_H
#define _THREADSDL_H

//@START_USER1
#include <OpenThreads/Thread>
#include "Evaluable.h"
#include <map>
#include <vector>
#include <osg/Timer>
#include <SDL/SDL_thread.h>
namespace cooki3d{
//@END_USER1


/*@NOTE_1101
class ...
*/

class AFX_EXT_CLASS ThreadSdl
    : public Evaluable
{

//@START_USER2
//@END_USER2

//
// Group: ClassBuilder methods
//

private:
    void ConstructorInclude();
    void DestructorInclude();

//
// Non-Grouped Members
//

private:
    SDL_Thread* _thread;

protected:
    bool _vivant;
    bool _runEnd;

//
// Non-Grouped Methods
//

public:
    ThreadSdl(BD* pBD);
    virtual ~ThreadSdl();
    void kill();
    virtual void run();
    void start();
};

#endif


#ifdef CB_INLINES
#ifndef _THREADSDL_H_INLINES
#define _THREADSDL_H_INLINES

//@START_USER3
} //end of namespace cooki3d
//@END_USER3

#endif
#endif
