/** -*-c++-*- *************************************************************\
* (Remise  zro le 24/10/04, 23/06/06, 14/11/06)
* File:          Threadd.cpp
* Creation date: November 14, 2006 00:37
* Author:        Bertrand Greslier
*                Entreprise Individuelle
* Purpose:       Declaration of class 'Threadd'
*
* Modifications: @INSERT_MODIFICATIONS(* )
*
* Copyright (C) 2006, Bertrand Greslier
* This file is part of Cooki3d API
*
* This file may be used under the terms of the GNU General Public
* License version 2.0 as published by the Free Software Foundation
* and appearing in the file LICENSE.GPL included in the packaging of
* this file.  
*
* If you are unsure which license is appropriate for your use, please
* review the following information:
* www.cooki3d.org => licence or 
* contact the author at bertrand.greslier@gmail.com.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
\**************************************************************************/
//@START_USER1
//@END_USER1


// Master include file
#include "CookiMetier.h"


//@START_USER2
#include "Threadd.h"
#include "LoaderXML.h"
namespace cooki3d{
//@END_USER2




/*@NOTE_779
Constructor method.
*/
Threadd::Threadd(BD* pBD) //@INIT_779
    : Evaluable(pBD)
    , _vivant(true)
    , _runEnd(true)
{//@CODE_779
    ConstructorInclude();
    
    //assertC(_taches.size());
    //_tacheIT=_taches.begin();
        
    setName( "thread" );

    // Put in your own code
    cout<<"new Threadd"<<endl;
}//@CODE_779


/*@NOTE_771
Destructor method.
*/
Threadd::~Threadd()
{//@CODE_771
    DestructorInclude();

    // Put in your own code

}//@CODE_771


void Threadd::kill()
{//@CODE_781
    _vivant = false;
        
    cout<<"kill thread : "<<this<<endl;

    while (!_runEnd);

    cout<<"kill thread : "<<this<<" OK"<<endl;

}//@CODE_781


void Threadd::run()
{//@CODE_780
    _runEnd = false;
    this->run2();
    _runEnd = true;
}//@CODE_780


void Threadd::run2()
{//@CODE_790
    assertCMessage(0,"Threadd::run2() pure virtual methode");
}//@CODE_790


//{{AFX DO NOT EDIT CODE BELOW THIS LINE !!!

/*@NOTE_772
Method which must be called first in a constructor.
*/
void Threadd::ConstructorInclude()
{
}


/*@NOTE_773
Method which must be called first in a destructor.
*/
void Threadd::DestructorInclude()
{
}


// Methods for the relation(s) of the class

//}}AFX DO NOT EDIT CODE ABOVE THIS LINE !!!

//@START_USER3
} //end of namespace cooki3d
