#!/bin/bash

#ext prints extension of a file, including "."
function ext()
{
    #echo "appel ext !!"
    local name=${1##*/}
    local name0="${name%.*}"
    local ext=${name0:+${name#$name0}}
    echo "${ext:-.}"
}

#force l'execute de commande dont la syntaxe est pour moi bonne
#mais qu'une subtilité d'interpretation empeche de fonctionner
function forceExecute(){

    echo $* > command.txt
    sh command.txt > /dev/stdout
}

function creerLesGroupes(){
    ############################################################
    #Récuparation de la notion de groupe dans le code ClassBuilder
    #en plaçant des //@{ en premier et //@} en dernier 
    #-----------------------------------------------------------
    

    echo "fichier:"$FIC
    EXT=`ext $FIC`

    
    if [ "$EXT" == ".cpp" ]; then
	#on remplace tous les " Enf of Group:..." des fichier .cpp par /*@}*/
	sed 's/[//][//] End of Group:.*/\/*@}*\//' $FIC.etp2 > $FIC.etpX
	mv $FIC.etpX $FIC.etp2  #on repart du bon fichier
	#cat $FIC.etp2
	#exit 0
    else
	#on retire le groupe ClassBuilder du fichier car ce groupe 
	#est privé et de plus n'apparait pas dans le cpp ce qui pose
	#deux probleme
	grep -v "ClassBuilder" $FIC.etp2 > $FIC.etpX
	mv $FIC.etpX $FIC.etp2  #on repart du bon fichier
    fi

    
    #LIST_GRP=( `grep "[- ]Group[:e]" $FIC.etp2 -n | sed 's/\([0-9].*[0-9]\).*/\1/'` )
    #on ne veut que les vrai groupes
    #donc pas de "Non-Grouped..." et de "Group: ClassBuilder" qui est un groupe
    #privé TODO: on pourra changer ce filtre qui ne set plus à rien
    LIST_GRP=( `grep " Group:" $FIC.etp2 -n | grep -v "ClassBuilder" |  sed 's/\([0-9].*[0-9]\).*/\1/'` )

    #echo "#LIST_GRP="${#LIST_GRP[@]}
    #echo "LIST_GRP="${LIST_GRP[@]}
    PREMIER="true"
    DECAL="0"
    
	#test...
        #echo ${LIST_GRP[1]}
    
    if [ "${LIST_GRP[0]}" != "" ] ; then

	
        #echo "EXT="$EXT	
	
	
	for GRP_LIN in "${LIST_GRP[@]}" ; do
	    
	    #echo "GRP_LIN="$GRP_LIN
	    
	    GRP_LIN=`expr $GRP_LIN + $DECAL`
	    
		#dans tous les cas
		#on insert après le numero (sed a) une ouverture de groupe
	    sed ${GRP_LIN}'a/*@{*/' $FIC.etp2 > $FIC.etpX
	    
	    DECAL=`expr $DECAL + 1` #on incremente le decalage	
	    mv $FIC.etpX $FIC.etp2  #on repart du bon fichier
	    
		#si ce n'est pas le premier numéro de ligne
		#on insert avant le numero (sed i) une fermeture de groupe
	    if [ "$PREMIER" == "" ] ; then
		if [ "$EXT" == ".h" ]; then
		    #echo "Non premier !!"
		    sed ${GRP_LIN}'i/*@}*/' $FIC.etp2 > $FIC.etpX
		    #echo $GRP_LIN
		    DECAL=`expr $DECAL + 1` #on incremente le decalage	
		    mv $FIC.etpX $FIC.etp2  #on repart du bon fichier
		fi
	    else
		#echo "premier="$GRP_LIN
		PREMIER=""
	    fi
	    
	    
	done
	

	#il faut fermer le dernier group juste  
	#si on est dans un header
	if [ "$EXT" == ".h" ]; then

	    LAST_LINE_GRP=(`grep "Non-Grouped" $FIC.etp2  -n | sed 's/\([0-9].*[0-9]\).*/\1/'`)

	    #cas 1, un groupe Non-Grouped existe 
	    #à la suite des groupes valides...
	    #on ne fait alors rien, la premiere valeur du tableau 
	    #est la bonne


	    #cas 2,
	    #il faut fermer le dernier group juste avant la dernier "};"
            #récupération d'un tableau de numéros de lignes
	    if [ "${#LAST_LINE_GRP[@]}" == "0" ] ; then

		LAST_LINE_GRP=(`grep "^};" $FIC.etp2  -n | sed 's/\([0-9].*[0-9]\).*/\1/'`)
		if [ "${#LAST_LINE_GRP[@]}" != "1" ] ; then
		    #echo "LAST_LINE_GRP="${LAST_LINE_GRP[@]}
		    #echo "Nb="${#LAST_LINE_GRP[@]}
		    INDEX=`expr ${#LAST_LINE_GRP[@]} - 1`
		    #echo "index="$INDEX
		    LAST_LINE_GRP=${LAST_LINE_GRP[${INDEX}]}
		    #echo $LAST_LINE_GRP
		    #exit 0
		fi
	    fi
	    
	    #on effectue l'insertion
	    sed ${LAST_LINE_GRP}'i/*@}*/' $FIC.etp2 > $FIC.etpX
	    mv $FIC.etpX $FIC.etp2  #on repart du bon fichier
	fi


	#Placement des /**  */ autour '// Group : XXXX ' uniquement
	#sauf groupe ClassBuilder et groupes privé
	sed 's/[//][//] Group:\(.*\)/\/**@name\1*\//' $FIC.etp2 > $FIC.etpX
	
	mv $FIC.etpX $FIC.etp2  #on repart du bon fichier

	echo "groupes existants traités."
    fi
}

function convertToUnixFormat(){
    #renommage
    mv $FIC $FIC.old

    ############################################################
    #conversion des fins de lignes de fichiers DOS en mode UNIX...
    # IN UNIX ENVIRONMENT: convert DOS newlines (CR/LF) to Unix format
    #detection des CR/LF
    DETECT_CRLF=`file $FIC.old | grep "CRLF"`
    
    if [ "$DETECT_CRLF" != "" ]; then	
	# assumes that all lines end with CR/LF (enlève le dernier caractère)
	sed 's/.$//' $FIC.old >  $FIC.etp1
    else
	echo $FIC": pas des fin de ligne dos à supprimer"
	cp $FIC.old  $FIC.etp1
    fi
}

function suppressionEntetes(){
    ############################################################
    # Suppression des entêtes...
    # on cherche la dernière ligne de l'entête
    LIN_END=`grep "\*\*\*/" $FIC.etp1 -n | sed 's/.*\([0-9][0-9]\).*/\1/' `
 

    if [ "$LIN_END" != "" ] ; then #si on a un numero	
	# affichage informations
	#echo $FIC,$LIN_END

	#méthode porc de secours,on passe par un fichier intermédaire
	#pour executer la commande (salope(rie) de syntaxe...) 
	#suppression du fichier jusqu'à la Xième ligne
	#echo "sed '1,"$LIN_END"d' "$FIC.etp1" > "$FIC.etp2 > command$FIC.txt
       	#sh command$FIC.txt
	
        COM="sed '1,"$LIN_END"d' "$FIC.etp1" > "$FIC.etp2
	forceExecute $COM

    else	
	# affichage informations
	echo $FIC": pas de suppression d'entête"
	cp $FIC.etp1 $FIC.etp2
    fi
}
    

DOC_REP=doc

#création du répertoire de documentation
rm -fr $DOC_REP
mkdir $DOC_REP

#Animati
cp *.{cpp,h} $DOC_REP

#changement de répertoire
cd $DOC_REP

#filtre
rm CookiMetier.h

#test
#ls > tmp.txt


#pour chaque fichier
for FIC in $( ls ); do

    #conversion des fins de lignes de fichiers DOS en mode UNIX...
    convertToUnixFormat
    #mv $FIC $FIC.etp1 #on saut cette étape

    # Suppression des entêtes...
    suppressionEntetes
    #mv $FIC.etp1 $FIC.etp2
    
    ############################################################
    #Récuparation de la notion de groupe dans le code ClassBuilder
    #en plaçant des //@{ en premier et //@} en dernier 
    #-----------------------------------------------------------
    creerLesGroupes
       
		


    ############################################################
    #Conversion et suppression des commentaires pour que doc++ 
    # se passe bien...
    #-----------------------------------------------------------
    #on enleve les //@START_xxxx //@CODE_xxxx
       #on remplace les @NOTE_xxxx par '*' 
          #on enleve les commentaires du type //...
             #on enleve les lignes type class QString;
    sed 's/[//][//]@.*//' $FIC.etp2  |                                                 sed 's/@NOTE_[0-9]*/*/'  |                                                         sed 's/[//][//].*//' >> $FIC.etp3 

#   |                                                          sed 's/class [a-zA-Z].*;//' 


    
    # $FIC.etp3 > $FIC.etp4


    docify $FIC.etp3 $FIC

   #doc++ --dir html$FIC $FIC
    
    #mv $FIC.etp4 $FIC

    rm -f *.etp* *.txt *.old

done

echo "Génération de la doc avec doxygen..."
cp ../configFileDoxy .
doxygen configFileDoxy &>log.txt

#POST Traitement
echo "POST Traitement"
    #insertion du diagramme de classes
cp ../Metier.png htmlDoxygen/html

#ajoute un \n avant <hr...
sed 's/><hr/>\n<hr/' htmlDoxygen/html/index.html > htmlDoxygen/html/indexTmp.html

#récupération du numéro de ligne
LIST_NUM=( `grep "<hr" htmlDoxygen/html/indexTmp.html -n |  sed 's/\([0-9][0-9]*\):.*/\1/'` )

echo "LIST_NUM=$LIST_NUM"

#LIST_NUM_PREM=${LIST_GRP[0]}


#echo "LIST_NUM_PREM=$LIST_NUM_PREM"

#insertion de ligne à l'endroit voulu
sed ${LIST_NUM}'i\<center><img src="Metier.png" border="0"></center>' htmlDoxygen/html/indexTmp.html > htmlDoxygen/html/index.html
rm htmlDoxygen/html/indexTmp.html

#mv htmlDoxygen/html/indexNew.html htmlDoxygen/html/index.html

#echo "Génération de la doc avec doc++..."
#doc++ --dir html Animation.cpp Animation.h
#doc++ -A --dir html [A-C]*.h [A-C]*.cpp
#doc++ --dir html P*.h P*.cpp

#doc++ -A --dir html *.h *.cpp



#doc++ --dir html EvtSouris.h EvtSouris.cpp

#Commande final
#doc++ --dir html *.{h,cpp}
#doc++ -A --dir html *.{h,cpp}

#nettoyage
    
#######################################################################"
#POUBELLE

#sed 's/^M$//' # in bash/tcsh, press Ctrl-V then Ctrl-M
#sed 's/\x0D$//' # gsed 3.02.80, but top script is easier

#tous les fichier sauf un
#ls | grep -v '^mon_fichier.txt$' | xargs rm

#function recupNumLigne(){
#
#    COM="echo \"$1\" -n | sed 's/\([0-9][0-9]\).*/\1/' >/dev/stdout"
#
#    #echo $COM > command.txt
#    #LINE_NUM=`sh command.txt`
#    
#    forceExecute $COM
#}


#	#PLUS MAINTENTANT,on ne fait plus comme ca !!
#	#il faut fermer le dernier group juste avant la dernier "};" 
#	#de déclaration fin de classe si on est d'un header
#	if [ "$EXT" == ".h" ]; then

#	    #récupération d'un tableau de numéros de lignes
#	    LAST_LINE_GRP=(`grep "^};" $FIC.etp2  -n | sed 's/\([0-9].*[0-9]\).*/\1/'`)
#	    if [ "${#LAST_LINE_GRP[@]}" != "1" ] ; then
#		#echo "LAST_LINE_GRP="${LAST_LINE_GRP[@]}
#		#echo "Nb="${#LAST_LINE_GRP[@]}
#		INDEX=`expr ${#LAST_LINE_GRP[@]} - 1`
#		#echo "index="$INDEX
#		LAST_LINE_GRP=${LAST_LINE_GRP[${INDEX}]}
#		#echo $LAST_LINE_GRP
#		#exit 0
#	    fi
#	
#	    sed ${LAST_LINE_GRP}'i/*@}*/' $FIC.etp2 > $FIC.etpX
#	    mv $FIC.etpX $FIC.etp2  #on repart du bon fichier
#	fi

	
        #Placement des /**  */ autour des '// Non-GroupedXXXX' 
	#et des '// Group : XXXX '
	#sed 's/[//][//] Non-Grouped\(.*\)/\/**@name other\1*\//' $FIC.etp2                    | sed 's/[//][//] Group:\(.*\)/\/**@name\1*\//' > $FIC.etpX
